

	switch(state) {
		case npc_state.IDLE:
			// clear path
			//if (path_get_number(way) > 0) {
			//	path_clear_points(way);
			//}
			
			computed_way = false;
			break;
			
		case npc_state.GOTO_RES:
			if (computed_way == false) {
				mp_grid_path(obj_controller.grid, way, x, y, item.x, item.y, true);
				path_start(way, default_speed, path_action_stop, false);
				computed_way = true;
			}
			
			if (path_position == 1) {
				state = npc_state.gathered;
				timer = gather_time;
				computed_way = false;
			}
			break;
			
		case npc_state.gathered:
			if (timer > 0) {
				timer--;
			} else {
				gathered = item.object_index;
				instance_destroy(item);
				state = npc_state.GOTO_BLD;
				computed_way = false;
			}
			break;
		
		case npc_state.GOTO_BLD:
			if (computed_way == false) {
				mp_grid_path(obj_controller.grid, way, x, y, assignation.x, assignation.y, true);
				path_start(way, default_speed, path_action_stop, false);
				computed_way = true;
			}
			
			if (path_position == 1) {
				var _npc = id;
				var _found = false;
				with (assignation) {
					_found = scr_find_items_for_npc(_npc);
				}
				
				if (_found == false) {
					state = npc_state.GOTO_REST;
					assignation = noone;
					item = noone;
					gathered = noone;
				}
				
				computed_way = false;
			}
			
			break;
			
		case npc_state.GOTO_REST:
			if (computed_way == false) {
				mp_grid_path(obj_controller.grid, way, x, y, xstart, ystart, true);
				path_start(way, default_speed, path_action_stop, false);
				computed_way = true;
			}
			
			if (path_position == 1) {
				computed_way = false;
				state = npc_state.IDLE;
			}
			
	}